/*
 * Buxton
 *
 * Copyright (C) 2019 Samsung Electronics Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the License);
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#pragma once

#ifdef __cplusplus
extern "C" {
#endif

#include <tizen_error.h>

typedef enum _buxton_error {
	BUXTON_ERROR_NONE = TIZEN_ERROR_NONE,
	BUXTON_ERROR_INVALID_PARAMETER = TIZEN_ERROR_INVALID_PARAMETER, /**< Invalid parameter */
	BUXTON_ERROR_OUT_OF_MEMORY = TIZEN_ERROR_OUT_OF_MEMORY, /**< Out of memory */
	BUXTON_ERROR_IO_ERROR = TIZEN_ERROR_IO_ERROR, /**< I/O error */
	BUXTON_ERROR_PERMISSION_DENIED = TIZEN_ERROR_PERMISSION_DENIED, /**< Permission denied */
	BUXTON_ERROR_INVALID_OPERATION = TIZEN_ERROR_INVALID_OPERATION, /**< Function not implemented */
	BUXTON_ERROR_NOT_EXIST = TIZEN_ERROR_NO_SUCH_FILE,
	BUXTON_ERROR_EXIST = TIZEN_ERROR_FILE_EXISTS,
	BUXTON_ERROR_TIME_OUT = TIZEN_ERROR_CONNECTION_TIME_OUT,
	BUXTON_ERROR_DATA_TOO_LONG = TIZEN_ERROR_FILE_NAME_TOO_LONG,
	BUXTON_ERROR_INTERRUPTED = TIZEN_ERROR_INTERRUPTED_SYS_CALL

} buxton_error_e;

char* buxton_err_get_str(int err);
void buxton_err_set_errno(int err);
int buxton_err_get_errno();

#ifdef __cplusplus
}
#endif
