/*
 * Buxton
 *
 * Copyright (C) 2016 Samsung Electronics Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the License);
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#pragma once

void cache_init(void);
void cache_insert(enum buxton_layer_type layer_type, const char *key,
		uint8_t *data, int len);
void cache_remove(enum buxton_layer_type layer_type, const char *key);
void cache_update_data(enum buxton_layer_type layer_type, const char *key,
		uint8_t *data, int len);
int cache_get(enum buxton_layer_type layer_type, const char *key,
		void **data, int *data_len);

void cache_clear(enum buxton_layer_type layer_type);
